#ifndef CSTEAMWORKS_H
#define CSTEAMWORKS_H

#include "steam_gameserver.h" // Includes steam_api internally
#include "steamencryptedappticket.h"

#if defined( _WIN32 )
#define SB_API extern "C"  __declspec( dllexport )
#elif defined( GNUC )
#define SB_API extern "C" __attribute__ ((visibility ("default")))
#else
#define SB_API extern "C"
#endif

// A few functions return CSteamID which can not be done when using extern "C"
// We could slam it directly to uint64, but that doesn't give other wrappers the info they require for autogen.
typedef uint64 SteamID_t;

#ifdef VERSION_SAFE_STEAM_API_INTERFACES
SB_API ISteamUser *S_CALLTYPE SteamUser();
SB_API ISteamFriends *S_CALLTYPE SteamFriends();
SB_API ISteamUtils *S_CALLTYPE SteamUtils();
SB_API ISteamMatchmaking *S_CALLTYPE SteamMatchmaking();
SB_API ISteamUserStats *S_CALLTYPE SteamUserStats();
SB_API ISteamApps *S_CALLTYPE SteamApps();
SB_API ISteamNetworking *S_CALLTYPE SteamNetworking();
SB_API ISteamMatchmakingServers *S_CALLTYPE SteamMatchmakingServers();
SB_API ISteamRemoteStorage *S_CALLTYPE SteamRemoteStorage();
SB_API ISteamScreenshots *S_CALLTYPE SteamScreenshots();
SB_API ISteamHTTP *S_CALLTYPE SteamHTTP();
SB_API ISteamUnifiedMessages *S_CALLTYPE SteamUnifiedMessages();
SB_API ISteamController *S_CALLTYPE SteamController();
SB_API ISteamUGC *S_CALLTYPE SteamUGC();
#ifdef _PS3
SB_API ISteamPS3OverlayRender *S_CALLTYPE SteamPS3OverlayRender();
#endif // _PS3

SB_API ISteamGameServer *S_CALLTYPE SteamGameServer();
SB_API ISteamUtils *S_CALLTYPE SteamGameServerUtils();
SB_API ISteamNetworking *S_CALLTYPE SteamGameServerNetworking();
SB_API ISteamGameServerStats *S_CALLTYPE SteamGameServerStats();
SB_API ISteamHTTP *S_CALLTYPE SteamGameServerHTTP();
#endif // VERSION_SAFE_STEAM_API_INTERFACES

#endif // CSTEAMWORKS_H
